/*
 * File:		io.c
 * Purpose:		Serial Input/Output routines
 *
 */

#include "src/init/m523xevb.h"

/********************************************************************/
char
uart0_in_char (void)
{
	/* Wait until character has been received */
	while (!(MCF_UART_USR0 & MCF_UART_USR_RXRDY))
		; 
	return MCF_UART_URB0;
}
/********************************************************************/
void
uart0_out_char (char ch)
{
	/* Wait until space is available in the FIFO */
	while (!(MCF_UART_USR0 & MCF_UART_USR_TXRDY))
		;
	/* Send the character */
	MCF_UART_UTB0 = ch;
}

/********************************************************************/
int
uart0_char_present (void)
{
	return (MCF_UART_USR0 & MCF_UART_USR_RXRDY);
}

/********************************************************************/
char
uart1_in_char (void)
{
	/* Wait until character has been received */
	while (!(MCF_UART_USR1 & MCF_UART_USR_RXRDY))
		; 
	return MCF_UART_URB1;
}
/********************************************************************/
void
uart1_out_char (char ch)
{
	/* Wait until space is available in the FIFO */
	while (!(MCF_UART_USR1 & MCF_UART_USR_TXRDY))
		;
	/* Send the character */
	MCF_UART_UTB1 = ch;
}

/********************************************************************/
int
uart1_char_present (void)
{
	return (MCF_UART_USR1 & MCF_UART_USR_RXRDY);
}

/********************************************************************/
char
uart2_in_char (void)
{
	/* Wait until character has been received */
	while (!(MCF_UART_USR2 & MCF_UART_USR_RXRDY))
		; 
	return MCF_UART_URB2;
}
/********************************************************************/
void
uart2_out_char (char ch)
{
	/* Wait until space is available in the FIFO */
	while (!(MCF_UART_USR2 & MCF_UART_USR_TXRDY))
		;
	/* Send the character */
	MCF_UART_UTB2 = ch;
}

/********************************************************************/
int
uart2_char_present (void)
{
	return (MCF_UART_USR2 & MCF_UART_USR_RXRDY);
}

/********************************************************************/
