/*
 * File:		int_handlers.c
 * Purpose:		Interrupt handlers
 *
 * Notes:		Any interrupt or exception is a fatal error.
 */

#include "m523xevb.h"

/********************************************************************/

#define RESULTS		*((uint32 *)(SRAM_ADDRESS))
#define VECTOR(v)	(v & 0xFF) << 24

void 
exception_handler (void *framep) 
{
	/* Catastrophic failure */
	RESULTS |= VECTOR(MCF5XXX_RD_SF_VECTOR(framep));

	#ifndef __MWERKS__
		asm(" halt");
	#else
		asm( halt);
	#endif
}

/********************************************************************/
